"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var most_subject_1 = require("most-subject");
var Engine = (function () {
    function Engine() {
        this.intentStream = most_subject_1.async();
        this.historyStream = most_subject_1.async();
        this.travelStream = most_subject_1.async();
    }
    Engine.prototype.observe = function (actionsSinks, f, end) {
        var errorHandled = actionsSinks
            .recoverWith(function (e) {
            console.error('There is Error in your reducer:', e, e.stack);
            return errorHandled;
        });
        return errorHandled
            .subscribe({
            next: f,
            error: function (e) { return console.error('Something is Wrong:', e, e.stack); },
            complete: end
        });
    };
    return Engine;
}());
exports.default = Engine;
